	;------------------------
	;- TRAIN RUSH BY XAVSNAP-
	;------------------------
	
	ORG +16514
	B9  "R" "A" "I" "N" "-"
	B7  "U" "S" "H"
	76 76
	
@LEVEL 
	00
@MILES 
	00 00
@LENGHT
	00 00
@LIFE  
	04 00
@SCOREDTA
	00 00
	
	JP INIT     ; 16535
	JP ANIM1    ; 16538
	JP ANIM2    ; 16541
	JP USAMAP   ; 16544
	JP TABLE    ; 16547
	
	;CITY LOCATION(MAP)
	1E 0A 1D 0B 1C 0B 19 0B
	16 0B 14 0A 10 0B 0B 0B
	0A 0B 06 0B 02 0C 01 0E
	
	;LEVEL 
@MISCHR
	"12345678"
	
@TIMER 06 00
	
	JP SCL2     ;16584
	
	JP TESTUDG  ;16587
	JP INITUDG  ;16590
	JP RESETUDG ;16593
	JP UDG1     ;16596
	JP UDG2     ;16599
	JP UDG3     ;16602
	JP UDGGAME  ;16605
	JP INVVAR   ;16608
	
	
	; INIT ASM2 VARS
	
@DEST=+16402
@DFILE=+16396
@DFCC=+16398
@FAST=2D6
@FRAMES=+16436
@SEED=+16434
@SLOW=2BF
@CLS=A2A
@KEYLOW=+16421
@KEYHI=+16422
	
	;UDG
@UDGROM=1E00
	
	
	
@INIT  LD A,0
	LD (FINISHED),A
	LD (TSTAT),A
	LD (MULTI),A
	
	LD A,(ISUDG)
	CP 1
	JP NZ NOUDG
	CALL UDGGAME
@NOUDG 
	LD HL,0
	LD (MILES),HL
	
	
	;INIT TRAIN LOCATION
	LD HL,(DFILE)
	LD BC,1DC
	ADD HL,BC
	LD (LOCDATA),HL
	CALL DISP1
	
	;INIT OBJDATA
	LD HL,(DFILE)
	LD BC,+32
	ADD HL,BC
	LD (OBJDATA),HL
	
	CALL OBJECTS
	
	;INIT SCORE LOCATION
	LD HL,(DFILE)
	LD BC,2F9
	ADD HL,BC
	LD (SCORELOC),HL
	LD BC,+11
	ADD HL,BC
	LD (MILESLOC),HL
	
	CALL SETLIFE
	CALL AMULTI
	
	;MAIN PROGRAM
@MAIN1 
	LD A,(LIFE)
	DEC A  
	JP M KILLED
	
	LD BC,(MILES)
	INC BC
	LD (MILES),BC
	 
	LD BC,+35
	LD HL,(LENGHT)
	ADD HL,BC
	LD BC,(MILES)
	SBC HL,BC
	JP M END1
	
	CALL DISPMILES
	CALL CLRSHIP
	CALL DISP1
	LD BC,(MILES)
	LD HL,(LENGHT)
	SBC HL,BC
	JP M ARRIVED
	
	CALL OBJECTS
	
	LD HL,(MILES)
	LD A,L
	CP FF
	JR NZ MAIN2
	CALL DMULTI
	
@MAIN2 CALL SCROLL
	CALL KBTEST1
	CALL TSTBYTE
	CALL DISP2
	CALL TIME
	JP MAIN1
	RET
	
@DISP1 
	LD HL,(LOCDATA)
	LD A,(ISUDG)
	CP 1
	JP Z DISP11
	LD (HL),8A
	DEC HL
	LD (HL),94
	DEC HL
	LD (HL),2  
	DEC HL
	LD (HL),"."
	RET
	
@DISP11
	LD (HL),"-"
	DEC HL
	LD (HL),"+"
	DEC HL
	LD (HL),"."
	DEC HL
	LD (HL),"."
	RET
	
@DISP2 
	LD HL,(LOCDATA)
	LD A,(TSTAT)
	CP 0
	RET Z
	CP 1
	JP NZ DISP22
	LD BC,+33
	SBC HL,BC
	
@DISP22
	LD A,(ISUDG)
	CP 1
	JP Z DISP23
	LD (HL),09
	DEC HL
	LD (HL),83
	DEC HL
	LD (HL),87
	DEC HL
	LD (HL)," "
	LD BC,+36
	ADD HL,BC
	LD (HL),03
	DEC HL
	LD (HL),03
	DEC HL
	LD (HL),0B
	DEC HL
	LD (HL),0B
	RET
@DISP23
	LD (HL),","
	DEC HL
	LD (HL),";"
	DEC HL
	LD (HL),"_"
	DEC HL
	LD (HL)," "
	LD BC,+36
	ADD HL,BC
	LD (HL),":"
	DEC HL
	LD (HL),0B
	DEC HL
	LD (HL),"="
	RET
	
	
@KBTEST1
	LD A,0
	LD (TSTAT),A
	LD A,(KEYLOW)
	CP +239
	CALL Z KBTEST2
	CP +127
	JP Z END2
	CP +191
	CALL Z KBTEST3
	RET
	
@KBTEST2
	LD A,(KEYHI)
	CP +223
	CALL Z DESC
	CP +239
	CALL Z MONT
	RET
	
@KBTEST3
	LD A,(KEYHI)
	CP +251
	CALL Z NLIFE
	RET
	
@DESC                 
	LD A,01
	LD (TSTAT),A
	LD HL,(LOCDATA)
	LD BC,+33
	ADD HL,BC
	LD (LOCDATA),HL
	
	LD BC,+33
	LD HL,(SCORELOC)
	SBC HL,BC
	LD B,H
	LD C,L
	LD HL,(LOCDATA)
	SBC HL,BC
	;OFF SCREEN
	JP P ERR1
	RET
@ERR1  
	LD HL,(LOCDATA)
	LD BC,+33
	SBC HL,BC
	LD (LOCDATA),HL
	RET
	
@MONT  
	LD A,02
	LD (TSTAT),A
	LD HL,(LOCDATA)
	LD BC,+33
	SBC HL,BC
	LD (LOCDATA),HL
	
	LD HL,(DFILE)
	LD BC,(LOCDATA)
	SBC HL,BC
	JP P ERR2
	RET
@ERR2  
	LD HL,(LOCDATA)
	LD BC,+33
	ADD HL,BC
	LD (LOCDATA),HL
	RET
	
@NLIFE 
	LD HL,SCOREDTA
	LD BC,3E8
	SBC HL,BC
	JP M NLEND
	CALL INVERT
	CALL INVERT
	LD A,(LIFE)
	INC A
	CP +9
	RET Z
	LD (LIFE),A
	CALL SETLIFE
	LD HL,SCOREDTA
	LD BC,3E8
	SBC HL,BC
	LD (SCOREDTA),HL
@NLEND 
	RET
	
	
@TSTBYTE
	LD HL,(LOCDATA)
	LD A,(HL)   
	CP "$"
	CALL Z PRISE1
	CP "B"
	CALL Z PRISE2
	CP +189
	CALL Z EXPLO1
	CP +137
	CALL Z EXPLO1
	CP +138
	CALL Z EXPLO1
	CP "#"
	CALL Z JAM
	CP +133
	CALL Z EXPLO1
	CP +5
	CALL Z EXPLO1
	CP +8
	CALL Z EXPLO1
	CP "A"
	CALL Z TAKEALL
	CP "H"
	CALL Z ALLX
	CP "X"
	CALL Z ALLXR
	CP ")" 
	CALL Z RIV
	CP "<"
	CALL Z ZIG
	CP 9E ; "2"
	CALL Z AMULTI
	CP 9F
	CALL Z AMULTI
	CP A0
	CALL Z AMULTI
	CP A1
	CALL Z AMULTI
	CP A2
	CALL Z AMULTI
	CP A3
	CALL Z AMULTI
	CP A4
	CALL Z AMULTI
	CP A5 ; "9"
	CALL Z AMULTI
	CALL DISP1
	RET
	
@CLRSHIP
	LD A,(TSTAT)
	CP 2
	JP Z CLR1
	CP 0
	JP Z CLR1
	LD HL,(LOCDATA)
	LD BC,+33
	SBC HL,BC
	LD (HL)," "
	DEC HL
	LD (HL)," "
	DEC HL
	LD (HL)," "
	DEC HL
	LD (HL)," "
@CLR1  LD HL,(LOCDATA)
	LD (HL)," "
	DEC HL
	LD (HL)," "
	DEC HL
	LD (HL)," "
	DEC HL
	LD (HL)," "
	
	CP 0
	RET Z
	CP  1
	RET Z
	LD BC,+36
	ADD HL,BC
	LD (HL)," "
	DEC HL
	LD (HL)," "
	DEC HL
	LD (HL)," "
	DEC HL
	LD (HL)," "
	RET
	
	; SCREEN SCROLLING
	
@SCROLL
	SCF
	CCF
	LD HL,(DFILE)
	INC HL
	INC HL
	LD (SCROFF),HL
	LD A,+22
@SCRL1 
	LD HL,(SCROFF)
	LD DE,(SCROFF)
	DEC DE
	LD BC,+31
	LDIR
	
	ADD HL,BC
	DEC HL
	LD (HL),0
	LD BC,+33
	LD HL,(SCROFF)
	ADD HL,BC
	LD (SCROFF),HL
	DEC A
	JP NZ SCRL1
	RET
	
@SCROFF
	00 00
	
@SCROLL2
	RET
	
@OBJECTS
	
	;FIRST OBJECT
	LD BC,+33
	LD HL,(OBJDATA)
	LD A,(FRAMES)
	ADD A,A
	ADD A,A
	ADD A,B
	AND +31
	SUB +10
	JP P OBJ1
	ADD A,+22
	
	;DRAW IT
@OBJ1  
	ADD HL,BC
	DEC A
	JP NZ OBJ1
	;SELECT CHAR IN "MISCHR"
	LD (LOCCHAR),HL
	LD A,(FRAMES)
	LD BC,(MILES)
	ADD A,C
	BIT 1,C
	JP Z MI1
	ADD A,A
@MI1   
	XOR +7
	ADD A,B
	AND +7
	LD HL,MISCHR
	LD B,0
	LD C,A
	ADD HL,BC
	LD A,(HL)
	LD HL,(LOCCHAR)
	LD (HL),A
	LD BC,(LOCCHAR)
	
	;SECOND OBJECT
	LD HL,(OBJDATA)
	LD A,(FRAMES)
	ADD A,A    
	ADD A,B
	AND +31
	LD BC,+33
	SUB +10
	JP P OBJ2
	ADD A,+22
	
	;DRAW IT
@OBJ2  
	ADD HL,BC
	DEC A
	JP NZ OBJ2
	LD (HL),+189  ;INV X
	
	LD BC,(MILES)
	BIT 6,C
	JP DISPJAM
	BIT 7,C
	RET Z
	LD HL,(OBJDATA)
	LD A,(FRAMES)
	ADD A,A
	ADD A,B
	ADD A,A
	AND +31
	LD BC,+33
	SUB +10
	JP P OBJ3
	ADD A,+21
@OBJ3  
	ADD HL,BC
	DEC A
	JP NZ OBJ3
	LD (HL),"B"  ;BONUS
	RET
	
@DISPJAM
	LD HL,(OBJDATA)
	LD A,(FRAMES)
	ADD A,A
	ADD A,A
	ADD A,B
	AND +31
	LD BC,+33
	SUB +10
	JP P DISPJ1
	ADD A,+21
@DISPJ1
	ADD HL,BC
	DEC A
	JP NZ DISPJ1
	LD (HL),"$"  ; 5$
	RET
	
@AMULTI
	; ADD X2 X3 ...
	LD A,(MULTI)
	INC A
	LD (MULTI),A
	LD HL,(SCORELOC)
	LD BC,+8
	ADD HL,BC
	ADD A, 9C
	LD (HL),A
	LD A,0
	RET
	
@DMULTI
	; DISPLAY MULTI.
	LD HL,(OBJDATA)
	LD  A,(FRAMES)
	ADD A,A
	ADD A,A
	AND +31
	LD BC,+33
	SUB +10
	JP P DM1
	ADD A,+21
@DM1   
	ADD HL,BC
	DEC A
	JR NZ DM1
	LD A,(HL)
	CP 0
	JR NZ DMULTI
	LD A,(MULTI)
	ADD A,9D
	LD (HL),A
	LD A,0
	RET
	
@PRISE1 ; $$$$
	LD HL,(LOCDATA)
	LD BC,+4
	SBC HL,BC
	LD A,(MULTI)
	LD (HL),+10
	DEC HL
	LD (HL),8
	DEC HL
	ADD A,9C
	LD (HL),A
	DEC HL
	LD (HL),BD
	DEC HL
	LD (HL),8D
	DEC HL
	LD (HL),A1 
	DEC HL
	LD (HL),8
	
	LD BC,5
	CALL MUL
	LD A,0
	RET
	
	
@MUL   LD A,(MULTI)
	LD HL,(SCOREDTA)
@MUL1  
	ADD HL,BC
	DEC A
	JR NZ MUL1
	LD (SCOREDTA),HL
	CALL DISPSCORE
	RET
	
@PRISE2 ; BONUS
	LD HL,(LOCDATA)
	LD BC,+4
	SBC HL,BC
	LD (HL),+10
	DEC HL
	LD (HL),8
	DEC HL
	LD A,(MULTI)
	ADD A,9C
	LD (HL),A
	DEC HL
	LD (HL),BD
	DEC HL
	LD (HL),8D
	DEC HL
	LD (HL),9C
	DEC HL
	LD (HL),A1
	DEC HL
	LD (HL),8
	LD HL,(SCOREDTA)
	LD BC,+50
	CALL MUL
	LD A,0
	RET
	
@EXPLO1
	CALL CLRSHIP
	CALL DISP1
	LD HL,(LOCDATA)
	
	LD (HL), 97 ; *
	
	CALL INVERT
	CALL INVERT
	
	LD BC,(LIFE)
	DEC BC
	LD (LIFE),BC
	LD HL,(SCORELOC)
	ADD HL,BC
	LD BC,+23
	ADD HL,BC
	LD A,(HL)
	CP +137
	JR Z EXP1
	LD (HL),80
	DEC HL
	LD A,(HL)
	CP +137
	JR Z EXP1
	LD (HL),">"
@EXP1  LD A,0
	RET
	
@INVERT
	LD HL,(DFILE)
	LD B,17
	DEC HL
	
@INVL2 INC HL
	LD A,(HL)
	CP 76   
	JR NZ INVL1
	DJNZ INVL2
	RET
@INVL1 ADD A,80
	LD (HL),A
	JR INVL2
	RET
	
@KILLED
	LD BC,0
	CALL WIND1
	
	LD HL,(DFCC)
	LD BC,3
	ADD HL,BC
	LD (HL),+172 ;"G"
	INC HL
	LD (HL),+166 ;"A"
	INC HL
	LD (HL),+178 ;"M"
	INC HL
	LD (HL),+170 ;"E"
	INC HL
	INC HL
	INC HL
	LD (HL),+180 ;"O"
	INC HL
	LD (HL),+187 ;"V"
	INC HL
	LD (HL),+170 ;"E"
	INC HL
	LD (HL),+183 ;"R"
	LD A,1
	LD (LEVEL),A
	LD HL,0
	LD (LIFE),HL
	LD BC,1
	RET    
	
@WIND1 
	LD HL,(DFILE)
	LD BC,+338
	ADD HL,BC
	
	LD A,+7
	LD (HL),A
	INC HL
	
	LD C,+16
	LD A,+3
@WIN11 LD (HL),A
	INC HL
	DEC C
	JP NZ WIN11
	
	LD A,84
	LD (HL),A
	
	LD BC,+16
	ADD HL,BC
	LD A,05
	LD (HL),A
	INC HL
	
	;SAVE TEXT POS.
	LD (DFCC),HL
	
	LD C,+16
	LD A,80
	
@WIN12 LD (HL),A
	INC HL
	DEC C
	JP NZ WIN12
	
	LD A,85
	LD (HL),A
	
	LD BC,+16
	ADD HL,BC
	LD A,82
	LD (HL),A
	INC HL
	
	LD BC,+16
	LD A,83
	
@WIN13 LD (HL),A
	INC HL
	DEC C
	JP NZ WIN13
	
	LD A,81
	LD (HL),A
	
	RET
	
@WIND2 
	RET
	
@DISPMILES
	
	LD HL,(MILES)
	LD DE,(MILESLOC)
	LD BC,-10000
	CALL NUM1
	LD BC,-1000
	CALL NUM1
	LD BC,-100
	CALL NUM1
	LD C,-10
	CALL NUM1
	LD C,-1
	
@NUM1  LD A,+155
@NUM2  INC A
	ADD HL,BC
	JR C NUM2
	SBC HL,BC
	LD (DE),A
	INC DE
	RET
	
@DISPSCORE
	LD HL,(SCOREDTA)
	LD DE,(SCORELOC)
	LD BC,-10000
	CALL NUM3
	LD BC,-1000
	CALL NUM3
	LD BC,-100
	CALL NUM3
	LD C,-10
	CALL NUM3
	LD C,-1
	
@NUM3  LD A,+155
@NUM4  INC A
	ADD HL,BC
	JR C NUM4
	SBC HL,BC
	LD (DE),A
	INC DE
	RET
	
@ARRIVED
	LD A,(FINISHED)
	INC A
	LD (FINISHED),A
	SUB +11
	JP P MAIN2
	
	LD A,(FINISHED)
	LD HL,(OBJDATA)
	LD BC,+33
@ARR1  ADD HL,BC
	DEC A
	JP NZ ARR1
	LD (HL),+138
	
	LD A,(FINISHED)
	LD HL,(OBJDATA)
	LD BC,+726
	ADD HL,BC
	LD BC,+33
@ARR2  SBC HL,BC
	DEC A
	JP NZ ARR2
	LD (HL),+137
	
	JP MAIN2
	
@END1  
	CALL WIND1
	LD HL,(DFCC)
	LD DE,CHREND1
@END1L1
	LD A,(DE)
	CP FF
	JP Z END1L2
	LD (HL),A
	INC DE
	INC HL
	JP END1L1
@END1L2
	CALL TIMER3
	LD A,(LEVEL)
	CP 0B
	JP Z WIN
	
	LD A,0
	LD (LEVEL),A
	JP EXIT
	
@END2  
	CALL WIND1
	LD HL,(DFCC)
	LD DE,CHREND2
@END2L1
	LD A,(DE)
	CP FF
	JP Z END2L2
	LD (HL),A
	INC DE
	INC HL
	JP END2L1
@END2L2
	LD HL,0
	LD (LIFE),HL
	LD A,2
	LD (LEVEL),A
	CALL TIMER3
	JP EXIT
	
@EXIT  
	LD BC,(LEVEL)
	RET
	
@SETLIFE
	LD HL,(SCORELOC)
	LD BC,+26
	ADD HL,BC
	LD (HL),80
	DEC HL
	LD (HL),80
	DEC HL
	LD (HL),80
	DEC HL
	LD A,(LIFE)
	DEC A
	JP Z SL2
	INC A
@SL1   LD (HL),+146
	INC HL
	DEC A
	JP NZ SL1
	DEC HL
@SL2   LD (HL),">"
	RET
	
@ANIM2 
	LD HL,(DFILE)
	LD BC,+13
	ADD HL,BC
	LD(ANIMLOC),HL
	LD A,+11
	LD(CMPA1),A
	JP ANI11
	
@ANIM1 
	LD HL,(DFILE)
	LD BC,+100
	ADD HL,BC
	LD A,+16
@LI1   LD (HL),+2
	INC HL
	LD (HL),+10
	INC HL
	DEC A
	JP NZ LI1
	
	LD BC,+562
	ADD HL,BC
	LD A,+16
@LI2   LD (HL),+2
	INC HL
	LD (HL),+10
	INC HL
	DEC A
	JP NZ LI2
	
	LD HL,(DFILE)
	INC HL
	LD (ANIMLOC),HL
	LD A,+12
	LD (CMPA1),A
	JP ANI11
@CMPA1 00
	
@ANI11 LD HL,CHRT1
	LD DE,(ANIMLOC)
	LD BC,9
	LDIR
	
	LD HL,(ANIMLOC)
	LD BC,+33
	ADD HL,BC
	EX DE,HL
	
	LD HL,CHRT2
	LD BC,+10
	LDIR
	
	LD HL,(ANIMLOC)
	LD BC,+66
	ADD HL,BC
	EX DE,HL
	
	LD HL,CHRT3
	LD BC,9
	LDIR
	
	LD A,(CMPA1)
	DEC A
	RET Z
	LD (CMPA1),A
	LD BC,(ANIMLOC)
	INC BC
	LD (ANIMLOC),BC
	
	LD A,+100
@SLDANI
	DEC A 
	JP NZ SLDANI
	LD HL,(ANIMLOC)
	LD BC,+72
	ADD HL,BC
	LD (HL),+138
	DEC HL
	LD (HL),+136
	DEC HL
	LD (HL),+137
	DEC HL
	LD (HL),+136
	CALL TIMER2
	
	JP ANI11
	
@JAM   
	LD HL,(DFILE)
	LD BC,+727
	ADD HL,BC
	LD (JAMOFF),HL
	
	LD HL,(DFILE)
	
	
@JAM3  INC HL
	
	LD (JAMOF2),HL
	LD HL,(JAMOFF)
	LD BC,(JAMOF2)
	SBC HL,BC
	JP M JAM5
	LD HL,(JAMOF2)
	LD A,(HL)
	CP +189
	JP Z JAM1
	CP "$"
	JP Z JAM2
	CP +137
	JP Z JAM4
	CP +138
	JP Z JAM4
	JP JAM3
@JAM5  LD A,0
	RET
	
@JAM1  
	LD (HL),"$"
	JP JAM3
	
@JAM2  
	LD (HL),+189
	JP JAM3
	
@JAM4  
	LD (HL),"B"
	JP JAM3
	
@JAMOFF
	00 00
@JAMOF2
	00 00
@ALLXR ;CHANGE X->$
	LD HL,(DFILE)
	LD BC,+727
	ADD HL,BC
	LD (JAMOFF),HL
	LD HL,(DFILE)
	INC HL
@ALXR1 INC HL
	LD (JAMOF2),HL
	LD HL,(JAMOFF)
	LD BC,(JAMOF2)
	SBC HL,BC
	JP Z ALXR3
	LD HL,(JAMOF2)
	LD A,(HL)
	CP BD ;"X"
	JP Z ALXR2
	JP ALXR1
@ALXR2 LD A,"$"
	LD (HL),A
	JP ALXR1
@ALXR3 
	LD A,0
	RET
	
	
@ALLX  
	LD HL,(DFILE)
	LD BC,+727
	ADD HL,BC
	LD (JAMOFF),HL
	LD HL,(DFILE)
	INC HL
@ALLX1 INC HL
	LD (JAMOF2),HL
	LD HL,(JAMOFF)
	LD BC,(JAMOF2)
	SBC HL,BC
	JP Z ALLXRET
	LD HL,(JAMOF2)
	LD A,(HL)
	CP"$"
	JP Z ALLX2
	JP ALLX1
	
@ALLX2 LD A,+189
	LD(HL),A
	JP ALLX1
	
@ALLXRET
	LD A,0
	RET
	
@TAKEALL
	;"A" CHAR.
	LD HL,(DFILE)
	LD BC,+727
	ADD HL,BC
	LD (JAMOFF),HL
	LD HL,(DFILE)
	LD (JAMOF2),HL
	
@TAKE1 
	INC HL
	LD (JAMOF2),HL
	LD HL,(JAMOFF)
	LD BC,(JAMOF2)
	SBC HL,BC
	JP Z TEND1
	LD HL,(JAMOF2)
	LD A,(HL)
	CP "$"
	JP Z TAKE2
	JP TAKE1
@TEND1 
	LD A,0
	RET
	
@TAKE2 
	LD A,"O"
	LD (HL),A  
	PUSH HL
	LD HL,(SCOREDTA)
	LD BC,+5
	ADD HL,BC
	LD (SCOREDTA),HL
	POP HL
	LD A,"+"
	LD (HL),A  
	CALL DISPSCORE
	LD HL,(JAMOF2)
	LD A,"."
	LD (HL),A  
	LD A," "
	LD (HL),A
	JP TAKE1
	
	
	
@ZIG   CALL TAKEALL
	LD D,0
	LD E,+11
	LD HL,(OBJDATA)
	INC HL
@ZIG1  DEC HL
	DEC HL
	DEC HL
	CALL DZIG
	LD BC,+66
	ADD HL,BC
	DEC E
	LD A,E
	CP 0
	JP Z RETZIG
	JP ZIG1
@RETZIG
	LD A,0
	RET
	
@RIV   CALL PRISE2
	LD D,0
	LD E,+10
	LD HL,(OBJDATA)
	INC HL
@RIV1  DEC HL
	DEC HL
	DEC HL
	CALL DRIV
	LD BC,+33
	ADD HL,BC
	DEC E
	LD A,E
	CP 0
	JP NZ RIV1
	LD BC,+66
	ADD HL,BC
	LD E,+10
@RIV2  DEC HL
	DEC HL
	DEC HL
	CALL DRIV
	LD BC,+33
	ADD HL,BC
	DEC E
	LD A,E
	CP 0
	JP NZ RIV2
	LD A,0
	RET
	
@DRIV  
	LD A,+133
	LD (HL),A
	INC HL
	LD A,+8
	LD (HL),A
	INC HL
	LD A,+5
	LD (HL),A
	INC HL
	RET
	
@DZIG  
	LD A,+138
	LD (HL),A
	INC HL
	INC HL
	LD A,+137
	LD (HL),A
	INC HL
	RET
	
@USAMAP
	LD HL,(DFILE)
	LD BC,+133
	ADD HL,BC
	EX DE,HL
	LD HL,4DE9
	LD BC,+654
	LDIR
	RET
	
@TABLE 
	LD A,+16
	LD HL,(DFILE)
	LD BC,9A
	ADD HL,BC
	LD (TAB1),HL
	LD HL, 507C
	LD (TAB2),HL
@TABL1 LD DE,(TAB1)
	LD HL,(TAB2)
	LD BC,0B
	LDIR
	DEC A
	RET Z
	LD HL,(TAB1)
	LD BC,+33
	ADD HL,BC
	LD (TAB1),HL
	LD HL,(TAB2)
	LD BC,+11
	ADD HL,BC
	LD (TAB2),HL
	JP TABL1
	
	RET
	
@TAB1  00 00
@TAB2  00 00
	
@TIME  
	LD A,(TIMER)
	LD B,A
@TIM2  LD C,+255
	
@TIM1  DEC C
	JP NZ TIM1
	DJNZ TIM2
	RET
	
@TIMER2
	LD BC, 4FF
	JP TIMB1
@TIMB2 LD C,+255
@TIMB1 DEC C
	JP NZ TIMB1
	DJNZ TIMB2
	RET
	
@TIMER3
	LD BC, 13FC
	JP TIMC1
@TIMC2 LD C,+255
@TIMC1 DEC C
	JP NZ TIMC1
	DJNZ TIMC2
	RET
	
@SCL2  
	LD A,+32
	LD (SCCMT),A
@SC21              
	CALL SCROLL
	LD A,(SCCMT)
	DEC A
	LD (SCCMT),A
	JP NZ SC21
	RET
	
@SCCMT 00
	
@WIN   ;WINNER
	CALL FAST
	CALL CLS
	LD A,(ISUDG)
	CP 0
	JR Z WINUDG
	CALL INITUDG
	CALL UDG1
	CALL UDG2
	CALL UDG4
@WINUDG
	CALL SLOW
	CALL WIND1
	LD HL,(DFCC)
	INC HL
	LD (HL), B8
	INC HL
	LD (HL), A6
	INC HL
	LD (HL), B3
	INC HL
	LD (HL), 80
	INC HL
	LD (HL), 80
	INC HL
	LD (HL), AB
	INC HL
	LD (HL), B7
	INC HL
	LD (HL), A6
	INC HL
	LD (HL), B3
	INC HL
	LD (HL), A8
	INC HL
	LD (HL), AE
	INC HL
	LD (HL), B8
	INC HL
	LD (HL), A8
	INC HL
	LD (HL), B4
	
	LD BC,+58
	ADD HL,BC
	LD (HL), 87
	INC HL
	LD (HL), AE
	INC HL
	LD (HL), AE
	INC HL
	LD (HL), 04
	
	LD BC,+16
	ADD HL,BC
	
	LD A,+16
@WIN1  
	LD (HL),2
	INC HL
	LD (HL),+10
	INC HL
	DEC A
	JP NZ WIN1
	
	LD A,1
	LD (ENDFUME),A
	LD BC,1
	LD (ENDOFF1),BC
	LD HL,(DFILE)
	LD BC,+395
	ADD HL,BC
	LD (ENDLOC1),HL
	
@WIN2  CALL WINA
	
	LD HL,(ENDOFF1)
	LD A,L
	CP +33
	JP NZ WIN2
	
	CALL FAST
	CALL CLS
	CALL SLOW
	
	LD HL,(DFILE)
	LD BC,+463
	ADD HL,BC
	
	LD A,+15
@WN21  LD (HL),08
	INC HL
	DEC A
	JP NZ WN21
	LD (HL),0A
	INC HL
	
	LD A,+8
@WN22  LD (HL),02
	INC HL
	LD (HL),0A
	INC HL
	DEC A
	JP NZ WN22
	INC HL
	
	LD A,+12
@WN23  LD (HL),08
	INC HL
	DEC A
	JP NZ WN23
	LD(HL),0A
	INC HL
	LD BC,+20
	ADD HL,BC
	
	LD A,+05
@WN24  LD (HL),0A
	INC HL
	LD (HL),08
	INC HL
	DEC A
	JP NZ WN24
	
	LD BC,+39
	SBC HL,BC
	LD A,(ISUDG)
	CP 0
	JP NZ FISH1
	LD (HL),92
	INC HL
	LD (HL),90
	INC HL
	LD (HL),99
	JP FISH2
@FISH1 
	LD (HL),"1"
	INC HL
	LD (HL),"2"
	INC HL
	LD (HL),"3"
@FISH2 
	LD BC,1
	LD (ENDOFF1),BC
	LD HL,(DFILE)
	LD BC,+395
	ADD HL,BC
	LD (ENDLOC1),HL
@WN3   
	CALL WINA
	
	LD HL,(ENDOFF1)
	LD A,L
	CP +29
	JP NZ WN3
	
	LD HL,(DFILE)
	LD BC,+272
	ADD HL,BC
	LD (HL),0F
	INC HL
	INC HL
	LD (HL),0F
	INC HL
	INC HL
	LD (HL),0F
	
	LD A,4
	LD (WNID),A
	
@WN5   
	CALL ENDSCR
	LD A,(WNID)
	CP 0
	JP NZ WN5
	LD HL,(DFILE)
	LD BC,+272
	ADD HL,BC
	LD (HL),0
	INC HL
	INC HL
	LD (HL),0
	INC HL
	INC HL
	LD (HL),0
	
	LD HL,(DFILE)
	LD BC,+369
	ADD HL,BC
	LD (HL), B9;"T"
	INC HL
	LD (HL),"H"
	INC HL
	LD (HL),"E"
	INC HL
	INC HL
	LD (HL), AA;"E"
	INC HL
	LD (HL),"N"
	INC HL
	LD (HL),"D"
	CALL TIMER3
	LD A,+4
	LD (WNID),A
	
@WN6   CALL ENDSCR
	LD A,(WNID)
	JP NZ WN6
	
	JP EXIT
	
@ENDSCR
	LD HL,(DFILE)
	LD BC,+398
	ADD HL,BC
	LD (ENDTS),HL
	LD BC,+33
	ADD HL,BC
	LD (ENDTT),HL
	
	CALL ENDDEP  
	
	LD HL,(DFILE)
	LD BC,+365
	ADD HL,BC
	LD (ENDTS),HL
	LD BC,+33
	ADD HL,BC
	LD (ENDTT),HL
	
	CALL ENDDEP
	
	LD HL,(DFILE)
	LD BC,+332
	ADD HL,BC
	LD (ENDTS),HL
	
	LD A,+12
@WN4   LD (HL),0
	INC HL
	DEC A
	JP NZ WN4
	
	LD HL,(ENDTS)
	LD BC,+33
	ADD HL,BC
	LD (ENDTT),HL
	
	CALL ENDDEP
	
	LD HL,(DFILE)
	LD BC,+332
	ADD HL,BC
	
	CALL TIMER3
	
	LD A,(WNID)
	DEC A
	LD (WNID),A
	RET
	
@ENDDEP
	LD HL,(ENDTS)
	LD DE,(ENDTT)
	LD BC,+12
	LDIR
	RET
	
@ENDTS 00 00
	
@ENDTT 00 00
	
@WINA  LD HL,(ENDLOC1)
	EX DE,HL
	LD HL,512C
	LD BC,(ENDOFF1)
	LDIR
	
	LD HL,(ENDLOC1)
	LD BC,+33
	ADD HL,BC
	EX DE,HL
	LD HL,514C
	LD BC,(ENDOFF1)
	LDIR
	
	LD HL,(ENDLOC1)
	LD BC,+66
	ADD HL,BC
	EX DE,HL  
	LD HL,516C
	LD BC,(ENDOFF1)
	LDIR
	
	LD A,(ENDFUME)
	CP 1
	JP Z WINF1
	CP 0
	JP Z WINF2
	
@RETFU LD HL,(ENDLOC1)
	DEC HL
	LD (ENDLOC1),HL
	
	LD HL,(ENDOFF1)
	INC HL
	LD (ENDOFF1),HL
	
	CALL TIMER2
	RET
	
@WINF1 
	LD HL,(ENDLOC1)
	LD BC,+33
	SBC HL,BC
	EX DE,HL
	LD HL,518C
	LD BC,(ENDOFF1)
	LDIR
	
	LD A,0
	LD (ENDFUME),A
	JP RETFU
	
@WINF2 
	LD HL,(ENDLOC1)
	LD BC,+33
	SBC HL,BC
	EX DE,HL
	LD HL,51AC
	LD BC,(ENDOFF1)
	
	LD A,1
	LD (ENDFUME),A
	JP RETFU
	
	
	;UDG
	;TEST
@TESTUDG
	LD HL,2000
	LD (UDGRAM),HL
	
@TUDG1 LD A,FF
	LD HL,(UDGRAM)
	LD (HL),A
	LD A,(HL)
	CP FF
	JP Z UDGOK
	LD BC,(UDGRAM)
	LD HL,400
	ADD HL,BC
	LD (UDGRAM),HL
	LD BC,4000
	SBC HL,BC
	JP NZ TUDG1
	
	LD HL,(DFILE)
	LD BC,+765
	ADD HL,BC
	LD DE,CHRUDG1
	CALL RDCHRI
	LD A,0
	LD (ISUDG),A
	LD BC,0
	RET
	
@UDGOK LD HL,(DFILE)
	LD BC,+767
	ADD HL,BC
	LD DE,CHRUDG2
	CALL RDCHR
	LD A,0
	LD (UDGRAM),A
	LD A,1
	LD (ISUDG),A
	LD BC,1
	RET
	
	
@RDCHRI
	LD A,(DE)
	CP FF
	RET Z
	XOR 80
	LD (HL),A
	INC DE
	INC HL
	JP RDCHRI
	
@RDCHR 
	LD A,(DE)
	CP FF
	RET Z
	LD (HL),A
	INC DE
	INC HL
	JP RDCHR
	
	;INITUDG
@INITUDG
	; SET IR TO RAM (2000H)
	LD HL,UDGROM
	LD DE,(UDGRAM)
	LD BC,+512
	LDIR
	LD DE,(UDGRAM)
	LD A,D
	LD I,A
	RET
	
@RESETUDG
	; RETURN TO ROM IR(1E00H)
	LD HL,UDGROM
	LD A,H
	LD I,A
	RET
	
@UDG1  ; A TO Z CHARS.
	LD HL,(UDGRAM)
	LD BC,130
	ADD HL,BC
	EX DE,HL
	
	LD HL,5310
	;D DE,2130
	LD BC,D0
	LDIR
	RET
	
@UDG2  ; 0 TO 9 CHARS.
	LD HL,(UDGRAM)
	LD BC,E0
	ADD HL,BC
	EX DE,HL
	
	LD HL,52C0
	;D DE,20E0
	LD BC,50
	LDIR
	
	;"*"
	LD HL,(UDGRAM)
	LD BC,B8
	ADD HL,BC
	EX DE,HL
	
	LD HL,51E0
	;D DE,20B8
	LD BC,8
	LDIR
	
	RET
	
@UDG3  ;INSTR.
	LD HL,(UDGRAM)
	LD BC,90
	ADD HL,BC
	EX DE,HL
	
	LD HL,51E8
	;D DE,2090
	LD BC,10
	LDIR
	
	LD HL,(UDGRAM)
	LD BC,60
	ADD HL,BC
	EX DE,HL
	
	LD HL,51F8
	;D DE,2060
	LD BC,10
	LDIR
	RET
	
@UDG4  ;END ANI
	LD HL,(UDGRAM)
	LD BC,E8
	ADD HL,BC
	EX DE,HL
	
	LD HL,5210
	;D DE,20E8
	LD BC,+24
	LDIR
	RET
	
@UDGGAME
	LD HL,(UDGRAM)
	LD BC,58
	ADD HL,BC
	EX DE,HL
	
	LD HL,5238
	;D DE,2058
	LD BC,88
	LDIR
	
	LD HL,(UDGRAM)
	LD BC,1E8
	ADD HL,BC
	EX DE,HL
	
	LD HL,5208
	;D DE,21E8
	LD BC,8
	
	RET
	
	
@INVVAR
	LD HL,(DEST)
	INC HL
	LD C,+14
	LD B,0
@INVAR1
	LD A,(HL)
	XOR 80
	RST 10
	INC HL
	DEC C
	JR NZ INVAR1
	RET
	
	
	
	;DATAS UDG
	
@ISUDG 00
	
@UDGRAM
	00 00
	
	;DATAS
	
@MULTI 
	00
@TSTAT 
	00
	
@LOCCHAR
	00 00
	
@LOCDATA
	00 00
	
@OBJDATA
	00 00
	
@SCORELOC
	00 00
	
@MILESLOC
	00 00
	
@FINISHED
	00
	
@ANIMLOC
	00 00
	
@ENDLOC1
	00 00
	
@ENDOFF1
	00 00
	
@ENDFUME
	00
	
@WNID  
	00
	
@CHREND1
	"LEVEL  COMPLETED" FF
@CHREND2
	"*** BREAKED. ***" FF
	
@CHRUDG1
	"- UDG RAM NOT FOUND -"
	FF
@CHRUDG2
	"- UDG AVAILABLE -" FF
	
	
@CHRT1 0 84 84 09 82 09 09 81 82
	00
@CHRT2 0 81 80 8A 8A 8A 8A 8A 8A
	05
@CHRT3 0 00 B4 B4 03 97 97 97 07
	00
@CHRT0 02 0A
	
	
	
	
	
